//: C05:Unroll.cpp
// Z knihy "Myslíme v jazyce C++, část 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Všechna práva vyhrazena.
// Přečtěte si podmínky používání zdrojových kódů umístěné v souboru 
// 'Licence.txt' dodávaném spolu s balíčkem kódu dostupným na www.MindView.net.
// Rozvine implicitné cyklus pomocí vložených funkcí.
#include <iostream>
using namespace std;

template<int n> inline int mocnina(int m) {
  return mocnina<n-1>(m) * m;
}

template<> inline int mocnina<1>(int m) {
  return m;
}

template<> inline int mocnina<0>(int m) {
  return 1;
}

int main() {
  int m = 4;
  cout << mocnina<3>(m) << endl;
} ///:~
